searchData={"items":[{"type":"module","title":"shards","doc":"Partitioned/Sharded ETS tables. Features shards implements the ETS API to keep compatibility and make the usage straightforward; exactly the same if you were using ets . Sharded or partitioned tables under-the-hood. This feature is managed entirely by shards and it is 100% transparent for the client. Provides a logical view of a single ETS table, but internally, it is composed by N number of partitions and each partition has associated an ETS table. High performance and scalability. shards keeps the lock contention under control enabling ETS tables to scale out and support higher levels of concurrency without lock issues; specially write-locks, which most of the cases might cause significant performance degradation. Partitioned Table When a table is created with shards:new/2 , a new supervision tree is created to represent the partitioned table. There is a main supervisor shards_partition_sup that create an ETS table to store the metadata and also starts the children which are the partitions to create. Each partition is owned by shards_partition (it is a gen_server ) and it creates an ETS table for storing data mapped to that partition. The supervision tree looks like: [ shards_partition ] -- &gt; &lt; ETS - Table &gt; / [ shards_partition_sup ] -- &lt;- [ shards_partition ] -- &gt; &lt; ETS - Table &gt; | \\ &lt; Metadata - ETS - Table &gt; [ shards_partition ] -- &gt; &lt; ETS - Table &gt; The returned value by shards:new/2 may be an atom if it is a named table or a reference otherwise, and in the second case the returned reference is the one of the metadata table, which is the main entry point and it is owned by the main supervisor. See shards:new/2 for more information. Usage &gt; Tab = shards : new ( tab , [ ] ) . # Ref &lt; 0.1541908042 . 2337144842.31535 &gt; &gt; shards : insert ( Tab , [ { a , 1 } , { b , 2 } , { c , 3 } ] ) . true &gt; shards : lookup ( Tab , a ) . [ { a , 1 } ] &gt; shards : lookup ( Tab , b ) . [ { b , 2 } ] &gt; shards : lookup ( Tab , c ) . [ { c , 3 } ] &gt; shards : lookup_element ( Tab , c , 2 ) . 3 &gt; shards : lookup ( Tab , d ) . [ ] &gt; shards : delete ( Tab , c ) . true &gt; shards : lookup ( Tab , c ) . [ ] As you can see, the usage is exactly the same if you were using ets , you can try the rest of the ETS API but with shards module. Important Despite shards aims to keep 100% compatibility with current ETS API, the semantic for some of the functions may be a bit different due to the nature of sharding; it is not the same having all the entries in a single table than distributed across multiple ones. For example, for query-based functions like select , match , etc., the returned entries are the same but not necessary the same order than ets . For first , next , and last they behave the similar in the sense by means of them a partitioned table is traversed, so the final result is the same, but the order in which the entries are traversed may be different. Therefore, it is highly recommended to read the documentation of the functions.","ref":"shards.html"},{"type":"function","title":"shards.all/0","doc":"Equivalent to ets:all() .","ref":"shards.html#all/0"},{"type":"function","title":"shards.delete/1","doc":"Equivalent to ets:delete/1 . See also: ets:delete/1 .","ref":"shards.html#delete/1"},{"type":"function","title":"shards.delete/2","doc":"Equivalent to delete(Tab, Key, shards_meta:get(Tab)) .","ref":"shards.html#delete/2"},{"type":"function","title":"shards.delete/3","doc":"Equivalent to ets:delete/2 . See also: ets:delete/2 .","ref":"shards.html#delete/3"},{"type":"function","title":"shards.delete_all_objects/1","doc":"Equivalent to delete_all_objects(Tab, shards_meta:get(Tab)) .","ref":"shards.html#delete_all_objects/1"},{"type":"function","title":"shards.delete_all_objects/2","doc":"Equivalent to ets:delete_all_objects/1 . See also: ets:delete_all_objects/1 .","ref":"shards.html#delete_all_objects/2"},{"type":"function","title":"shards.delete_object/2","doc":"Equivalent to delete_object(Tab, Object, shards_meta:get(Tab)) .","ref":"shards.html#delete_object/2"},{"type":"function","title":"shards.delete_object/3","doc":"Equivalent to ets:delete_object/2 . See also: ets:delete_object/2 .","ref":"shards.html#delete_object/3"},{"type":"function","title":"shards.file2tab/1","doc":"Equivalent to file2tab(Filename, []) .","ref":"shards.html#file2tab/1"},{"type":"function","title":"shards.file2tab/2","doc":"Equivalent to shards:file2tab/2 . Moreover, it restores the supervision tree for the shards corresponding to the given file, such as if they had been created using shards:new/2 . See also: ets:file2tab/2 .","ref":"shards.html#file2tab/2"},{"type":"function","title":"shards.first/1","doc":"Equivalent to first(Tab, shards_meta:get(Tab)) .","ref":"shards.html#first/1"},{"type":"function","title":"shards.first/2","doc":"Equivalent to ets:first/1 . However, the order in which results are returned might be not the same as the original ETS function, since it is a sharded table. See also: ets:first/1 .","ref":"shards.html#first/2"},{"type":"function","title":"shards.foldl/3","doc":"Equivalent to foldl(Fun, Acc, Tab, shards_meta:get(Tab)) .","ref":"shards.html#foldl/3"},{"type":"function","title":"shards.foldl/4","doc":"Equivalent to ets:foldl/3 . However, the order in which the entries are traversed may be different since they are distributed across multiple partitions. See also: ets:foldl/3 .","ref":"shards.html#foldl/4"},{"type":"function","title":"shards.foldr/3","doc":"Equivalent to foldr(Fun, Acc, Tab, shards_meta:get(Tab)) .","ref":"shards.html#foldr/3"},{"type":"function","title":"shards.foldr/4","doc":"Equivalent to ets:foldr/3 . However, the order in which the entries are traversed may be different since they are distributed across multiple partitions. See also: ets:foldr/3 .","ref":"shards.html#foldr/4"},{"type":"function","title":"shards.get_meta/2","doc":"Equivalent to get_meta(Tab, Key, undefined) .","ref":"shards.html#get_meta/2"},{"type":"function","title":"shards.get_meta/3","doc":"Wrapper for shards_meta:get/3 .","ref":"shards.html#get_meta/3"},{"type":"function","title":"shards.i/0","doc":"Equivalent to ets:i() .","ref":"shards.html#i/0"},{"type":"function","title":"shards.info/1","doc":"Similar to ets:info/1' but extra information about the partitioned table is added. Extra Info: {partitions, post_integer()} - Number of partitions. {keyslot_fun, shards_meta:keyslot_fun()} - Functions used for compute the keyslot. {parallel, boolean()} - Whether the parallel mode is enabled or not. See also: ets:info/1 .","ref":"shards.html#info/1"},{"type":"function","title":"shards.info/2","doc":"Equivalent to ets:info/2 . See the added items by shards:info/1 . See also: ets:info/2 .","ref":"shards.html#info/2"},{"type":"function","title":"shards.insert/2","doc":"Equivalent to insert(Tab, ObjOrObjs, shards_meta:get(Tab)) .","ref":"shards.html#insert/2"},{"type":"function","title":"shards.insert/3","doc":"Equivalent to ets:insert/2 . Despite this functions behaves exactly the same as ets:insert/2 and produces the same result, there is a big difference due to the nature of the sharding distribution model, IT IS NOT ATOMIC . Therefore, if it fails by inserting an object at some partition, previous inserts execution on other partitions are not rolled back, but an error is raised instead. See also: ets:insert/2 .","ref":"shards.html#insert/3"},{"type":"function","title":"shards.insert_new/2","doc":"Equivalent to insert_new(Tab, ObjOrObjs, shards_meta:get(Tab)) .","ref":"shards.html#insert_new/2"},{"type":"function","title":"shards.insert_new/3","doc":"Equivalent to ets:insert_new/2 . Despite this functions behaves exactly the same as ets:insert_new/2 and produces the same result, there is a big difference due to the nature of the sharding distribution model, IT IS NOT ATOMIC . Opposite to shards:insert/2 , this function tries to roll-back previous inserts execution on other partitions if it fails by inserting an object at some partition, but there might be race conditions during roll-back execution. Example: &gt; shards : insert_new ( mytab , { k1 , 1 } ) . true &gt; shards : insert_new ( mytab , { k1 , 1 } ) . false &gt; shards : insert_new ( mytab , [ { k1 , 1 } , { k2 , 2 } ] ) . false See also: ets:insert_new/2 .","ref":"shards.html#insert_new/3"},{"type":"function","title":"shards.is_compiled_ms/1","doc":"Equivalent to ets:is_compiled_ms(Term) .","ref":"shards.html#is_compiled_ms/1"},{"type":"function","title":"shards.last/1","doc":"Equivalent to ets:last/1 . However, the order in which results are returned might be not the same as the original ETS function, since it is a sharded table. See also: ets:last/1 .","ref":"shards.html#last/1"},{"type":"function","title":"shards.lookup/2","doc":"Equivalent to lookup(Tab, Key, shards_meta:get(Tab)) .","ref":"shards.html#lookup/2"},{"type":"function","title":"shards.lookup/3","doc":"Equivalent to ets:lookup/2 . See also: ets:lookup/2 .","ref":"shards.html#lookup/3"},{"type":"function","title":"shards.lookup_element/3","doc":"Equivalent to lookup_element(Tab, Key, Pos, shards_meta:get(Tab)) .","ref":"shards.html#lookup_element/3"},{"type":"function","title":"shards.lookup_element/4","doc":"Equivalent to ets:lookup_element/3 . See also: ets:lookup_element/3 .","ref":"shards.html#lookup_element/4"},{"type":"function","title":"shards.match/1","doc":"Equivalent to ets:match/1 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match/1 .","ref":"shards.html#match/1"},{"type":"function","title":"shards.match/2","doc":"Equivalent to match(Tab, Pattern, shards_meta:get(Tab)) .","ref":"shards.html#match/2"},{"type":"function","title":"shards.match/3","doc":"If 3rd argument is pos_integer() this function behaves like ets:match/3 , otherwise, the 3rd argument is assumed as shards_meta:t()` and it behaves like `ets:match/2 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match/2 , ets:match/3 .","ref":"shards.html#match/3"},{"type":"function","title":"shards.match/4","doc":"Equivalent to ets:match/3 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match/3 .","ref":"shards.html#match/4"},{"type":"function","title":"shards.match_delete/2","doc":"Equivalent to match_delete(Tab, Pattern, shards_meta:get(Tab)) .","ref":"shards.html#match_delete/2"},{"type":"function","title":"shards.match_delete/3","doc":"Equivalent to ets:match_delete/2 . See also: ets:match_delete/2 .","ref":"shards.html#match_delete/3"},{"type":"function","title":"shards.match_object/1","doc":"Equivalent to ets:match_object/1 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match_object/1 .","ref":"shards.html#match_object/1"},{"type":"function","title":"shards.match_object/2","doc":"Equivalent to match_object(Tab, Pattern, shards_meta:get(Tab)) .","ref":"shards.html#match_object/2"},{"type":"function","title":"shards.match_object/3","doc":"If 3rd argument is pos_integer() this function behaves like ets:match_object/3 , otherwise, the 3rd argument is assumed as shards_meta:t()` and it behaves like `ets:match_object/2 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match_object/3 .","ref":"shards.html#match_object/3"},{"type":"function","title":"shards.match_object/4","doc":"Equivalent to ets:match_object/3 . The order in which results are returned might be not the same as the original ETS function. See also: ets:match_object/3 .","ref":"shards.html#match_object/4"},{"type":"function","title":"shards.match_spec_compile/1","doc":"Equivalent to ets:match_spec_compile(MatchSpec) .","ref":"shards.html#match_spec_compile/1"},{"type":"function","title":"shards.match_spec_run/2","doc":"Equivalent to ets:match_spec_run(List, CompiledMatchSpec) .","ref":"shards.html#match_spec_run/2"},{"type":"function","title":"shards.member/2","doc":"Equivalent to member(Tab, Key, shards_meta:get(Tab)) .","ref":"shards.html#member/2"},{"type":"function","title":"shards.member/3","doc":"Equivalent to ets:member/2 . See also: ets:member/2 .","ref":"shards.html#member/3"},{"type":"function","title":"shards.new/2","doc":"This operation is equivalent to ets:new/2 , but when is called, instead of create a single ETS table, it creates a new supervision tree for the partitioned table. The supervision tree is composed by a main supervisor shards_partition_sup and N number of workers or partitions handled by shards_partition (partition owner). Each worker creates an ETS table to handle the partition. Also, the main supervisor shards_partition_sup creates an ETS table to keep the metadata for the partitioned table. Returns an atom if the created table is a named table, otherwise, a reference is returned. In the last case, the returned reference is the one of the metadata table, which is the main entry-point and it is owned by the main supervisor shards_partition_sup . Options: In addition to the options given by ets:new/2 , this functions provides the next options: {partitions, N} - Specifies the number of partitions for the sharded table. By default, N = erlang:system_info(schedulers_online) . {keyslot_fun, F} - Specifies the function used to compute the partition where the action will be evaluated. Defaults to erlang:phash2/2 . {parallel, P} - Specifies whether shards should work in parallel mode or not, for the applicable functions, e.g.: select , match , etc. By default is set to false . {parallel_timeout, T} - When parallel is set to true , it specifies the max timeout for a parallel execution. Defaults to infinity . Access: Currently, only public access is supported by shards:new/2 . Since a partitioned table is started with its own supervision tree when created, it is very tricky to provide private or protected access since there are multiple partitions (or ETS tables) and they are owned by the supervisor's children, and the supervisor along with their children (or partitions) are managed by shards under-the-hood; it is completely transparent for the client. Examples: &gt; Tab = shards : new ( tab1 , [ ] ) . # Ref &lt; 0.1541908042 . 2337144842.31535 &gt; &gt; shards : new ( tab2 , [ named_table ] ) . tab2 See also the &quot;Partitioned Table&quot; section at the module documentation for more information. See also: ets:new/2 .","ref":"shards.html#new/2"},{"type":"function","title":"shards.next/3","doc":"Equivalent to ets:next/2 . However, the order in which results are returned might be not the same as the original ETS function, since it is a sharded table. See also: ets:next/2 .","ref":"shards.html#next/3"},{"type":"function","title":"shards.partition_owners/1","doc":"Returns the partition PIDs associated with the given table TabOrPid .","ref":"shards.html#partition_owners/1"},{"type":"function","title":"shards.prev/2","doc":"Equivalent to ets:next/2 . However, the order in which results are returned might be not the same as the original ETS function, since it is a sharded table. See also: ets:prev/2 .","ref":"shards.html#prev/2"},{"type":"function","title":"shards.put_meta/3","doc":"Wrapper for shards_meta:put/3 .","ref":"shards.html#put_meta/3"},{"type":"function","title":"shards.rename/2","doc":"Equivalent to rename(Tab, Name, shards_meta:get(Tab)) .","ref":"shards.html#rename/2"},{"type":"function","title":"shards.rename/3","doc":"Equivalent to ets:rename/2 . Renames the table name and all its associated shard tables. If something unexpected occurs during the process, an exception will be raised. See also: ets:rename/2 .","ref":"shards.html#rename/3"},{"type":"function","title":"shards.safe_fixtable/2","doc":"Equivalent to safe_fixtable(Tab, Fix, shards_meta:get(Tab)) .","ref":"shards.html#safe_fixtable/2"},{"type":"function","title":"shards.select/1","doc":"Equivalent to ets:select/1 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select/1 .","ref":"shards.html#select/1"},{"type":"function","title":"shards.select/2","doc":"Equivalent to select(Tab, MatchSpec, shards_meta:get(Tab)) .","ref":"shards.html#select/2"},{"type":"function","title":"shards.select/3","doc":"If 3rd argument is pos_integer() this function behaves like ets:select/3 , otherwise, the 3rd argument is assumed as shards_meta:t()` and it behaves like `ets:select/2 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select/3 .","ref":"shards.html#select/3"},{"type":"function","title":"shards.select/4","doc":"Equivalent to ets:select/3 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select/3 .","ref":"shards.html#select/4"},{"type":"function","title":"shards.select_count/2","doc":"Equivalent to select_count(Tab, MatchSpec, shards_meta:get(Tab)) .","ref":"shards.html#select_count/2"},{"type":"function","title":"shards.select_count/3","doc":"Equivalent to ets:select_count/2 . See also: ets:select_count/2 .","ref":"shards.html#select_count/3"},{"type":"function","title":"shards.select_delete/2","doc":"Equivalent to select_delete(Tab, MatchSpec, shards_meta:get(Tab)) .","ref":"shards.html#select_delete/2"},{"type":"function","title":"shards.select_delete/3","doc":"Equivalent to ets:select_delete/2 . See also: ets:select_delete/2 .","ref":"shards.html#select_delete/3"},{"type":"function","title":"shards.select_replace/2","doc":"Equivalent to select_replace(Tab, MatchSpec, shards_meta:get(Tab)) .","ref":"shards.html#select_replace/2"},{"type":"function","title":"shards.select_replace/3","doc":"Equivalent to ets:select_replace/2 . See also: ets:select_replace/2 .","ref":"shards.html#select_replace/3"},{"type":"function","title":"shards.select_reverse/1","doc":"Equivalent to ets:select_reverse/1 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select_reverse/1 .","ref":"shards.html#select_reverse/1"},{"type":"function","title":"shards.select_reverse/2","doc":"Equivalent to select_reverse(Tab, MatchSpec, shards_meta:get(Tab)) .","ref":"shards.html#select_reverse/2"},{"type":"function","title":"shards.select_reverse/3","doc":"If 3rd argument is pos_integer() this function behaves like ets:select_reverse/3 , otherwise, the 3rd argument is assumed as shards_meta:t()` and it behaves like `ets:select_reverse/2 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select_reverse/3 .","ref":"shards.html#select_reverse/3"},{"type":"function","title":"shards.select_reverse/4","doc":"Equivalent to ets:select_reverse/3 . The order in which results are returned might be not the same as the original ETS function. See also: ets:select_reverse/3 .","ref":"shards.html#select_reverse/4"},{"type":"function","title":"shards.setopts/2","doc":"Equivalent to setopts(Tab, Opts, shards_meta:get(Tab)) .","ref":"shards.html#setopts/2"},{"type":"function","title":"shards.setopts/3","doc":"Equivalent to ets:setopts/2 . Returns true if the function was applied successfully on each partition, otherwise, false is returned. See also: ets:setopts/2 .","ref":"shards.html#setopts/3"},{"type":"function","title":"shards.tab2file/2","doc":"Equivalent to tab2file(Tab, Filename, []) .","ref":"shards.html#tab2file/2"},{"type":"function","title":"shards.tab2file/3","doc":"Equivalent to ets:tab2file/3 . This function generates one file per partition using ets:tab2file/3 , and also generates a master file with the given Filename that holds the information of the created partition files so that they can be recovered by calling ets:file2tab/1,2 . See also: ets:tab2file/3 .","ref":"shards.html#tab2file/3"},{"type":"function","title":"shards.tab2list/1","doc":"Equivalent to tab2list(Tab, shards_meta:get(Tab)) .","ref":"shards.html#tab2list/1"},{"type":"function","title":"shards.tab2list/2","doc":"Equivalent to ets:tab2list/1 . See also: ets:tab2list/1 .","ref":"shards.html#tab2list/2"},{"type":"function","title":"shards.tabfile_info/1","doc":"Equivalent to ets:tabfile_info/1 . Adds extra information about the partitions. See also: ets:tabfile_info/1 .","ref":"shards.html#tabfile_info/1"},{"type":"function","title":"shards.table/1","doc":"Equivalent to table(Tab, []) .","ref":"shards.html#table/1"},{"type":"function","title":"shards.table/2","doc":"Equivalent to table(Tab, Options, shards_meta:get(Tab)) .","ref":"shards.html#table/2"},{"type":"function","title":"shards.table/3","doc":"Similar to ets:table/2 , but it returns a list of qlc:query_handle() ; one per partition. See also: ets:table/2 .","ref":"shards.html#table/3"},{"type":"function","title":"shards.table_meta/1","doc":"Returns the metadata associated with the given table Tab .","ref":"shards.html#table_meta/1"},{"type":"function","title":"shards.take/2","doc":"Equivalent to take(Tab, Key, shards_meta:get(Tab)) .","ref":"shards.html#take/2"},{"type":"function","title":"shards.take/3","doc":"Equivalent to ets:take/2 . See also: ets:take/2 .","ref":"shards.html#take/3"},{"type":"function","title":"shards.test_ms/2","doc":"Equivalent to ets:test_ms(Tuple, MatchSpec) .","ref":"shards.html#test_ms/2"},{"type":"function","title":"shards.update_counter/3","doc":"Equivalent to update_counter(Tab, Key, UpdateOp, shards_meta:get(Tab)) .","ref":"shards.html#update_counter/3"},{"type":"function","title":"shards.update_counter/4","doc":"Equivalent to ets:update_counter/4 . If the 4th argument is shards_meta:t() , it behaves like ets:update_counter/3 . See also: ets:update_counter/4 .","ref":"shards.html#update_counter/4"},{"type":"function","title":"shards.update_counter/5","doc":"Equivalent to ets:update_counter/4 . See also: ets:update_counter/4 .","ref":"shards.html#update_counter/5"},{"type":"function","title":"shards.update_element/3","doc":"Equivalent to update_element(Tab, Key, ElementSpec, shards_meta:get(Tab)) .","ref":"shards.html#update_element/3"},{"type":"function","title":"shards.update_element/4","doc":"Equivalent to ets:update_element/3 . See also: ets:update_element/3 .","ref":"shards.html#update_element/4"},{"type":"type","title":"shards.access/0","doc":null,"ref":"shards.html#t:access/0"},{"type":"type","title":"shards.continuation/0","doc":null,"ref":"shards.html#t:continuation/0"},{"type":"type","title":"shards.ets_continuation/0","doc":null,"ref":"shards.html#t:ets_continuation/0"},{"type":"type","title":"shards.filename/0","doc":null,"ref":"shards.html#t:filename/0"},{"type":"type","title":"shards.info_item/0","doc":null,"ref":"shards.html#t:info_item/0"},{"type":"type","title":"shards.info_tuple/0","doc":null,"ref":"shards.html#t:info_tuple/0"},{"type":"type","title":"shards.option/0","doc":null,"ref":"shards.html#t:option/0"},{"type":"type","title":"shards.shards_opt/0","doc":null,"ref":"shards.html#t:shards_opt/0"},{"type":"type","title":"shards.tab/0","doc":null,"ref":"shards.html#t:tab/0"},{"type":"type","title":"shards.tabinfo_item/0","doc":null,"ref":"shards.html#t:tabinfo_item/0"},{"type":"type","title":"shards.tweaks/0","doc":null,"ref":"shards.html#t:tweaks/0"},{"type":"type","title":"shards.type/0","doc":null,"ref":"shards.html#t:type/0"},{"type":"module","title":"shards_enum","doc":"Provides a set of utilities to work with enumerables.","ref":"shards_enum.html"},{"type":"function","title":"shards_enum.map/2","doc":"Returns a list where each element is the result of invoking Fun on each corresponding element of Enumerable . For maps, the function expects a key-value tuple.","ref":"shards_enum.html#map/2"},{"type":"function","title":"shards_enum.pmap/2","doc":"Equivalent to pmap(Fun, infinity, Enumerable) .","ref":"shards_enum.html#pmap/2"},{"type":"function","title":"shards_enum.pmap/3","doc":"Similar to shards_enum:map/2 but it runs in parallel.","ref":"shards_enum.html#pmap/3"},{"type":"function","title":"shards_enum.reduce/3","doc":"Invokes Fun for each element in the Enumerable with the accumulator. The initial value of the accumulator is Acc0 . The function is invoked for each element in the enumerable with the accumulator. The result returned by the function is used as the accumulator for the next iteration. The function returns the last accumulator.","ref":"shards_enum.html#reduce/3"},{"type":"function","title":"shards_enum.reduce_while/3","doc":"Reduces enumerable until Fun returns {halt, AccOut} . The return value for Fun is expected to be {cont, AccOut} to continue the reduction with AccOut as the new accumulator or {halt, AccOut} to halt the reduction If fun returns {halt, AccOut} the reduction is halted and the function returns AccOut . Otherwise, if the enumerable is exhausted, the function returns the accumulator of the last {cont, AccOut} .","ref":"shards_enum.html#reduce_while/3"},{"type":"module","title":"shards_group","doc":"This module provides a dynamic supervisor for creating and/or deleting tables dynamically in runtime and as part of an existing supervision tree; any application supervision tree using shards . Usage To use shards and make the creates tables part of your application supervision tree, you have to add to your main supervisor: % Supervisor init callback init ( GroupName ) -&gt; Children = [ shards_group : child_spec ( GroupName ) ] , { ok , { { one_for_one , 10 , 10 } , Children } } . After your application starts, you can create and delete tables like so: &gt; { ok , Pid , Tab } = shards_group : new_table ( GroupName , mytab , [ named_table ] ) . { ok , &lt; 0.194 . 0 &gt; , # Ref &lt; 0.3052443831 . 2753691659.260835 &gt; } &gt; shards_group : del_table ( GroupName , mytab ) . ok","ref":"shards_group.html"},{"type":"function","title":"shards_group.child_spec/1","doc":null,"ref":"shards_group.html#child_spec/1"},{"type":"function","title":"shards_group.del_table/2","doc":null,"ref":"shards_group.html#del_table/2"},{"type":"function","title":"shards_group.init/1","doc":null,"ref":"shards_group.html#init/1"},{"type":"function","title":"shards_group.new_table/3","doc":null,"ref":"shards_group.html#new_table/3"},{"type":"function","title":"shards_group.start_link/0","doc":"Equivalent to start_link(shards_group) .","ref":"shards_group.html#start_link/0"},{"type":"function","title":"shards_group.start_link/1","doc":null,"ref":"shards_group.html#start_link/1"},{"type":"function","title":"shards_group.start_table/2","doc":null,"ref":"shards_group.html#start_table/2"},{"type":"function","title":"shards_group.stop/1","doc":"Equivalent to stop(Pid, 5000) .","ref":"shards_group.html#stop/1"},{"type":"function","title":"shards_group.stop/2","doc":null,"ref":"shards_group.html#stop/2"},{"type":"module","title":"shards_lib","doc":"Common Shards Utilities.","ref":"shards_lib.html"},{"type":"function","title":"shards_lib.get_sup_child/2","doc":"Searches the childern of the supervisor SupPid for a child whose Nth element compares equal to Id .","ref":"shards_lib.html#get_sup_child/2"},{"type":"function","title":"shards_lib.keyfind/2","doc":"Equivalent to keyfind(Key, KVList, undefined) .","ref":"shards_lib.html#keyfind/2"},{"type":"function","title":"shards_lib.keyfind/3","doc":"Returns the value to the given Key or Default if it doesn't exist.","ref":"shards_lib.html#keyfind/3"},{"type":"function","title":"shards_lib.keypop/2","doc":"Equivalent to keypop(Key, KVList1, undefined) .","ref":"shards_lib.html#keypop/2"},{"type":"function","title":"shards_lib.keypop/3","doc":"Searches the list of tuples KVList1 for a tuple whose Nth element compares equal to Key . Returns {Value, KVList2} if such a tuple is found, otherwise {Default, KVList1} . KVList2 is a copy of KVList1 where the first occurrence of Tuple has been removed.","ref":"shards_lib.html#keypop/3"},{"type":"function","title":"shards_lib.keyupdate/3","doc":"Equivalent to keyupdate(Fun, Keys, undefined, TupleList) .","ref":"shards_lib.html#keyupdate/3"},{"type":"function","title":"shards_lib.keyupdate/4","doc":"Updates the given Keys by the result of calling Fun(OldValue) . If Key doesn't exist, then Init is set.","ref":"shards_lib.html#keyupdate/4"},{"type":"function","title":"shards_lib.object_key/2","doc":"Returns the key for the given object or list of objects.","ref":"shards_lib.html#object_key/2"},{"type":"function","title":"shards_lib.read_tabfile/1","doc":"Reads the file info related to a tabfile saved previously.","ref":"shards_lib.html#read_tabfile/1"},{"type":"function","title":"shards_lib.to_string/1","doc":"Converts the input data to a string.","ref":"shards_lib.html#to_string/1"},{"type":"function","title":"shards_lib.write_tabfile/2","doc":"Writes to a file a content related to a table.","ref":"shards_lib.html#write_tabfile/2"},{"type":"type","title":"shards_lib.kv_list/0","doc":null,"ref":"shards_lib.html#t:kv_list/0"},{"type":"module","title":"shards_meta","doc":"This module encapsulates the partitioned table metadata. Different properties must be stored somewhere so shards can work properly. Shards perform logic on top of ETS tables, for example, compute the partition based on the Key where the action will be applied. To do so, it needs the number of partitions, the function to select the partition, and also the partition identifier to perform the ETS action.","ref":"shards_meta.html"},{"type":"function","title":"shards_meta.ets_opts/1","doc":null,"ref":"shards_meta.html#ets_opts/1"},{"type":"function","title":"shards_meta.from_map/1","doc":"Builds a new meta from the given Map .","ref":"shards_meta.html#from_map/1"},{"type":"function","title":"shards_meta.get/1","doc":"Returns the tab_info within the metadata.","ref":"shards_meta.html#get/1"},{"type":"function","title":"shards_meta.get/2","doc":"Equivalent to get(Tab, Key, undefined) .","ref":"shards_meta.html#get/2"},{"type":"function","title":"shards_meta.get/3","doc":"Returns the value for the given Key in the metadata, or Def if Key is not set.","ref":"shards_meta.html#get/3"},{"type":"function","title":"shards_meta.get_partition_pids/1","doc":"Returns a list with the partition PIDs.","ref":"shards_meta.html#get_partition_pids/1"},{"type":"function","title":"shards_meta.get_partition_tids/1","doc":"Returns a list with the partition TIDs.","ref":"shards_meta.html#get_partition_tids/1"},{"type":"function","title":"shards_meta.init/2","doc":"Initializes the metadata ETS table.","ref":"shards_meta.html#init/2"},{"type":"function","title":"shards_meta.is_metadata/1","doc":"Returns true if Meta is a metadata data type, otherwise, false is returned.","ref":"shards_meta.html#is_metadata/1"},{"type":"function","title":"shards_meta.keypos/1","doc":null,"ref":"shards_meta.html#keypos/1"},{"type":"function","title":"shards_meta.keyslot_fun/1","doc":null,"ref":"shards_meta.html#keyslot_fun/1"},{"type":"function","title":"shards_meta.lookup/2","doc":"Returns the value associated to the key Key in the metadata table Tab . If Key is not found, the error {unknown_table, Tab} is raised.","ref":"shards_meta.html#lookup/2"},{"type":"function","title":"shards_meta.new/0","doc":"Returns a metadata data type with the default values.","ref":"shards_meta.html#new/0"},{"type":"function","title":"shards_meta.parallel/1","doc":null,"ref":"shards_meta.html#parallel/1"},{"type":"function","title":"shards_meta.parallel_timeout/1","doc":null,"ref":"shards_meta.html#parallel_timeout/1"},{"type":"function","title":"shards_meta.partitions/1","doc":null,"ref":"shards_meta.html#partitions/1"},{"type":"function","title":"shards_meta.put/3","doc":"Stores the value Val under the given key Key into the metadata table Tab .","ref":"shards_meta.html#put/3"},{"type":"function","title":"shards_meta.rename/2","doc":"Renames the metadata ETS table.","ref":"shards_meta.html#rename/2"},{"type":"function","title":"shards_meta.tab_pid/1","doc":null,"ref":"shards_meta.html#tab_pid/1"},{"type":"function","title":"shards_meta.to_map/1","doc":"Converts the given Meta into a map .","ref":"shards_meta.html#to_map/1"},{"type":"type","title":"shards_meta.keyslot_fun/0","doc":null,"ref":"shards_meta.html#t:keyslot_fun/0"},{"type":"type","title":"shards_meta.meta_map/0","doc":null,"ref":"shards_meta.html#t:meta_map/0"},{"type":"type","title":"shards_meta.partition_pids/0","doc":null,"ref":"shards_meta.html#t:partition_pids/0"},{"type":"type","title":"shards_meta.partition_tids/0","doc":null,"ref":"shards_meta.html#t:partition_tids/0"},{"type":"type","title":"shards_meta.t/0","doc":null,"ref":"shards_meta.html#t:t/0"},{"type":"module","title":"shards_opts","doc":"Utilities for parsing the given shards/ets options..","ref":"shards_opts.html"},{"type":"function","title":"shards_opts.parse/1","doc":null,"ref":"shards_opts.html#parse/1"},{"type":"module","title":"shards_partition","doc":"Partition Owner. The partition owner is a gen_server that creates and holds the ETS table associated with the partition.","ref":"shards_partition.html"},{"type":"function","title":"shards_partition.apply_ets_fun/3","doc":null,"ref":"shards_partition.html#apply_ets_fun/3"},{"type":"function","title":"shards_partition.compute/2","doc":null,"ref":"shards_partition.html#compute/2"},{"type":"function","title":"shards_partition.handle_call/3","doc":null,"ref":"shards_partition.html#handle_call/3"},{"type":"function","title":"shards_partition.handle_cast/2","doc":null,"ref":"shards_partition.html#handle_cast/2"},{"type":"function","title":"shards_partition.handle_info/2","doc":null,"ref":"shards_partition.html#handle_info/2"},{"type":"function","title":"shards_partition.init/1","doc":null,"ref":"shards_partition.html#init/1"},{"type":"function","title":"shards_partition.pid/2","doc":null,"ref":"shards_partition.html#pid/2"},{"type":"function","title":"shards_partition.retrieve_tab/1","doc":null,"ref":"shards_partition.html#retrieve_tab/1"},{"type":"function","title":"shards_partition.start_link/4","doc":null,"ref":"shards_partition.html#start_link/4"},{"type":"function","title":"shards_partition.stop/1","doc":"Equivalent to stop(Server, 5000) .","ref":"shards_partition.html#stop/1"},{"type":"function","title":"shards_partition.stop/2","doc":null,"ref":"shards_partition.html#stop/2"},{"type":"function","title":"shards_partition.tid/2","doc":null,"ref":"shards_partition.html#tid/2"},{"type":"function","title":"shards_partition.tid/3","doc":null,"ref":"shards_partition.html#tid/3"},{"type":"module","title":"shards_partition_sup","doc":"This supervisor represents a partitioned table, which is composed by a group of ETS tables, each of them owned by shards_partition . This supervisor holds and handles the supervision tree for a partitioned table. Every time a new partioned table is created, a new supervision tree is created to handle its lifecycle, and this module is the main supervisor for that tree.","ref":"shards_partition_sup.html"},{"type":"function","title":"shards_partition_sup.init/1","doc":null,"ref":"shards_partition_sup.html#init/1"},{"type":"function","title":"shards_partition_sup.start_link/2","doc":null,"ref":"shards_partition_sup.html#start_link/2"},{"type":"function","title":"shards_partition_sup.stop/1","doc":"Equivalent to stop(Pid, 5000) .","ref":"shards_partition_sup.html#stop/1"},{"type":"function","title":"shards_partition_sup.stop/2","doc":null,"ref":"shards_partition_sup.html#stop/2"},{"type":"type","title":"shards_partition_sup.opts/0","doc":null,"ref":"shards_partition_sup.html#t:opts/0"},{"type":"extras","title":"Getting Started","doc":"# Getting Started","ref":"getting-started.html"},{"type":"extras","title":"Table of Contents - Getting Started","doc":"* __[Prelude](#prelude)__\n* __[Installation](#installation)__\n  * [Erlang](#erlang)\n  * [Elixir](#elixir)\n* __[Creating partitioned tables](#creating-partitioned-tables)__\n* __[Inserting entries](#inserting-entries)__\n* __[Retrieving entries](#retrieving-entries)__\n* __[Making partitioned tables part of an application's supervision tree](#making-partitioned-tables-part-of-an-applications-supervision-tree)__\n  * [Erlang example](#erlang-example)\n  * [Elixir example](#elixir-example)\n* __[Advanced topics](#advanced-topics)__\n  * __[Caching the metadata](#caching-the-metadata)__","ref":"getting-started.html#table-of-contents"},{"type":"extras","title":"Prelude - Getting Started","doc":"In this guide, we're going to learn some basics about `shards`, how to create\npartitioned tables and how to use them; which is the easiest part, since\nit is the same ETS API.","ref":"getting-started.html#prelude"},{"type":"extras","title":"Installation - Getting Started","doc":"","ref":"getting-started.html#installation"},{"type":"extras","title":"Erlang - Getting Started","doc":"In your `rebar.config`:\n\n```erlang\n{deps, [\n  {shards, \"1.1.0\"}\n]}.\n```","ref":"getting-started.html#erlang"},{"type":"extras","title":"Elixir - Getting Started","doc":"In your `mix.exs`:\n\n```elixir\ndef deps do\n  [{:shards, \"~> 1.1\"}]\nend\n```","ref":"getting-started.html#elixir"},{"type":"extras","title":"Creating partitioned tables - Getting Started","doc":"Exactly as ETS, `shards:new/2` function receives 2 arguments, the name of the\ntable and the options. But in addition to the options given by `ets:new/2`,\n`shards` provides the next ones:\n\n  * `{partitions, pos_integer()}` - Allows to set the desired number of\n    partitions. By default, the number of partitions is the total of online\n    schedulers (`erlang:system_info(schedulers_online)`).\n\n  * `{keyslot_fun, shards_meta:keyslot_fun()}` - Function used to compute the\n    partition where the action will be evaluated based on the key. Defaults to\n    `erlang:phash2/2`.\n\n  * `{parallel, boolean()}` - Specifies whether `shards` should work in parallel\n    mode or not, for the applicable functions, e.g.: `select`, `match`, etc. By\n    default is set to `false`.\n\n  * `{parallel_timeout, timeout()}` - When `parallel` is set to `true`, it\n    specifies the max timeout for a parallel execution. Defaults to `infinity`.\n\nWen a new table is created, the [metadata][shards_meta] is created for that\ntable as well. The purpose of the **metadata** is to store information related\nto that table, such as: number of partitions, keyslot function, etc. To learn\nmore about it, check out [shards_meta][shards_meta].\n\n[shards_meta]: https://github.com/cabol/shards/blob/master/src/shards_meta.erl\n\n**Erlang:**\n\n```erlang\n% create a named table with 4 shards\n> shards:new(tab1, [named_table, {partitions, 4}]).\ntab1\n\n% create another one with default options\n> shards:new(tab2, []).\n#Ref<0.893853601.1266286595.53859>\n```\n\n**Elixir:**\n\n```elixir\n# create a named table with 4 shards\niex> :shards.new(:tab1, [:named_table, partitions: 4])\n:tab1\n\n# create another one with default options\niex> :shards.new(:tab2, [])\n#Reference<0.1257361217.1909325839.17166>\n```\n\n> **NOTE:** You can also start the observer by calling `observer:start()`\n  to see how a partitioned table looks like.","ref":"getting-started.html#creating-partitioned-tables"},{"type":"extras","title":"Inserting entries - Getting Started","doc":"**Erlang:**\n\n```erlang\n> shards:insert(tab1, {k1, 1}).\ntrue\n> shards:insert(tab1, [{k1, 1}, {k2, 2}]).\ntrue\n\n> shards:insert_new(tab1, {k3, 3}).\ntrue\n> shards:insert_new(tab1, {k3, 3}).\nfalse\n> shards:insert_new(tab1, [{k3, 3}, {k4, 4}]).\nfalse\n```\n\n**Elixir:**\n\n```elixir\niex> :shards.insert(:tab1, k1: 1)\ntrue\niex> :shards.insert(:tab1, k1: 1, k2: 2)\ntrue\n\niex> :shards.insert_new(:tab1, k3: 3)\ntrue\niex> :shards.insert_new(:tab1, k3: 3)\nfalse\niex> :shards.insert_new(:tab1, k3: 3, k4: 4)\nfalse\n```","ref":"getting-started.html#inserting-entries"},{"type":"extras","title":"Retrieving entries - Getting Started","doc":"**Erlang:**\n\n```erlang\n% inserting some objects\n> shards:insert(tab1, [{k1, 1}, {k2, 2}, {k3, 3}]).\ntrue\n\n% let's check those objects\n> shards:lookup(tab1, k1).\n[{k1,1}]\n> shards:lookup(tab1, k2).\n[{k2,2}]\n> shards:lookup(tab1, k3).\n[{k3,3}]\n> shards:lookup(tab1, k4).\n[]\n\n> shards:lookup_element(tab1, k3, 2).\n3\n\n% delete an object and then check\n> shards:delete(tab1, k3).\ntrue\n> shards:lookup(tab1, k3).\n[]\n\n% now let's find all stored objects using select\n> MatchSpec = ets:fun2ms(fun({K, V}) -> {K, V} end).\n[{{'$1','$2'},[],[{{'$1','$2'}}]}]\n> shards:select(tab1, MatchSpec).\n[{k2,2},{k1,1}]\n```\n\n**Elixir:**\n\n```elixir\niex> :shards.insert(:tab1, k1: 1, k2: 2, k3: 3)\ntrue\n\niex> :shards.lookup(:tab1, :k1)\n[k1: 1]\niex> :shards.lookup(:tab1, :k2)\n[k2: 2]\niex> :shards.lookup(:tab1, :k3)\n[k3: 3]\niex> :shards.lookup(:tab1, :k4)\n[]\n\niex> :shards.lookup_element(:tab1, :k3, 2)\n3\n\niex> :shards.delete(:tab1, :k3)\ntrue\niex> :shards.lookup(:tab1, :k3)\n[]\n\niex> ms = :ets.fun2ms(& &1)\n[{:\"$1\", [], [:\"$1\"]}]\niex> :shards.select(:tab1, ms)\n[k2: 2, k1: 1]\n```\n\nAs you may have noticed using `shards` is extremely easy, it's only matters of\nusing the same ETS API but with `shards` module.\n\nYou can try the rest of the ETS API but using `shards`.","ref":"getting-started.html#retrieving-entries"},{"type":"extras","title":"Making partitioned tables part of an application's supervision tree - Getting Started","doc":"There might be some cases we may want to start the tables as part of an\nexisting supervision tree. To do so, we can create a dynamic supervisor\nfor taking care of creating/deleting the tables and add the dynamic\nsupervisor as part of our app supervision tree.\n\nShards provides the module `shards_group`, which is a dynamic supervisor that\ncan bee added to an existing application and/or supervision tree. Besides,\n`shards_group` brings with the function to create tables making them part of\nthe dynamic supervisor and also with the function to delete them and remove\nthem from the dynamic supervisor. But let's see how it works!","ref":"getting-started.html#making-partitioned-tables-part-of-an-application-s-supervision-tree"},{"type":"extras","title":"Erlang example - Getting Started","doc":"Supposing you have an application `myapp` and the main supervisor `myapp_sup`,\nthe only piece of configuration is to setup the `shards_group` as a supervisor\nwithin the application's supervision tree, like so:\n\n```erlang\n-module(myapp_sup).\n\n-export([start_link/1, init/1]).\n\nstart_link() ->\n  supervisor:start_link({name, ?MODULE}, ?MODULE, []).\n\ninit(_) ->\n  Children = [\n    % Dynamic supervisor with default name shards_group\n    % See shards_group:child_spec/1\n    shards_group:child_spec()\n  ],\n\n  {ok, {{one_for_one, 10, 10}, Children}}.\n```\n\n> The call `shards_group:child_spec()` will return the spec using the default\n  name for the dynamic supervisor `shards_group`, but can pass the desired name\n  by calling `shards_group:child_spec(desired_name)`.\n\nOnce the app is started, you can use `shards_group` to create/delete tables\nand `shards` for the rest of the API functions, like so:\n\n```erlang\n% create a table as part of the app supervision tree\n> shards_group:new_table(myapp_dynamic_sup, tab1, [named_table]).\n{ok,<0.194.0>,#Ref<0.3052443831.2753691659.260835>}\n\n> shards:insert(tab1, [{a, 1}, {b, 2}]).\ntrue\n> shards:lookup_element(tab1, a, 2).\n1\n\n% let's create another table\n> {ok, _Pid, Tab} = shards_group:new_table(myapp_dynamic_sup, tab2, []).\n{ok,<0.195.0>,#Ref<0.3052443831.2753691659.260836>}\n\n> shards:insert(tab2, [{c, 3}, {d, 4}]).\ntrue\n> shards:lookup_element(tab1, c, 2).\n3\n\n% you can open the observer to see hoe the tables look like\n> observer:start().\nok\n\n% deleting a table\n> shards_group:del_table(myapp_dynamic_sup, tab1).\ntrue\n```","ref":"getting-started.html#erlang-example"},{"type":"extras","title":"Elixir example - Getting Started","doc":"In Elixir is much easier it provides the `DynamicSupervisor` module out-of-box,\nso we have two options, either use `:shards_group` like before in the Erlang\nexample, or use `DynamicSupervisor` and create a simple module to encapsulate\nthe logic of creating/deleting tables. Since we already know how `:shards_group`\nworks in the previous example, let's take the second option.\n\nFirst of all, let's create the module to encapsulate the logic of creating and\ndeleting the tables:\n\n```elixir\ndefmodule MyApp.DynamicShards do\n  @moduledoc false\n\n  # creates a table with shards as part of the DynamicSupervisor which at\n  # the same time is part of the app supervision tree\n  def new(name, opts) do\n    {:ok, _pid, tab} =\n      DynamicSupervisor.start_child(__MODULE__, table_spec(name, opts))\n\n    tab\n  end\n\n  # deletes the table and also removes the table supervisor from the\n  # DynamicSupervisor\n  def delete(tab) do\n    DynamicSupervisor.terminate_child(__MODULE__, :shards_meta.tab_pid(tab))\n  end\n\n  # this functions encapsulates the logic of creating the sharded table\n  # as child of the DynamicSupervisor\n  def start_table(name, opts) do\n    tab = :shards.new(name, opts)\n    pid = :shards_meta.tab_pid(tab)\n    {:ok, pid, tab}\n  end\n\n  # DynamicSupervisor child spec\n  defp table_spec(name, opts) do\n    %{\n      id: name,\n      start: {__MODULE__, :start_table, [name, opts]},\n      type: :supervisor\n    }\n  end\nend\n```\n\nThe final piece of configuration is to setup a `DynamicSupervisor` as a\nsupervisor within the application's supervision tree, which we can do in\n`lib/my_app/application.ex`, inside the `start/2` function:\n\n```elixir\ndef start(_type, _args) do\n  children = [\n    {DynamicSupervisor, strategy: :one_for_one, name: MyApp.DynamicShards}\n  ]\n\n  ...\n```\n\nNow we can use `:shards`:\n\n```elixir\niex> MyApp.DynamicShards.new(:t1, [:named_table])\n:t1\niex> t2 = MyApp.DynamicShards.new(:t2, [])\n#Reference<0.2506606486.3592028173.65798>\n\niex> :shards.insert(:t1, a: 1, b: 2)\ntrue\niex> :shards.insert(t2, c: 3, d: 4)\ntrue\n\niex> :shards.lookup_element(:t1, :a, 2)\n1\niex> :shards.lookup_element(t2, :c, 2)\n3\n\n# open the observer\niex> :observer.start()\nok\n\n# delete a table\niex> MyApp.DynamicShards.delete(:t1)\n:ok\n```","ref":"getting-started.html#elixir-example"},{"type":"extras","title":"Advanced topics - Getting Started","doc":"","ref":"getting-started.html#advanced-topics"},{"type":"extras","title":"Storing and retrieving custom metadata entries - Getting Started","doc":"Since `shards` uses an internal ETS table for the metadata, it also provides\nhelper functions for storing and retrieving custom metadata entries.\n\n```erlang\n> Tab = shards:new(mytab, [named_table, {partitions, 4}]).\nmytab\n\n> shards:put_meta(Tab, foo, bar).\nok\n\n> shards:get_meta(Tab, foo).\nbar\n\n% Non-existing key\n> shards:get_meta(Tab, foo_foo).\nundefined\n\n% With default\n> shards:get_meta(Tab, foo_foo, bar_bar).\nbar_bar\n```\n\n**Elixir:**\n\n```elixir\niex> tab = :shards.new(:mytab, [:named_table, partitions: 4])\n:mytab\n\niex> :shards.put_meta(tab, \"foo\", \"bar\")\n:ok\n\niex> :shards.get_meta(tab, \"foo\")\n\"bar\"\n\n# Non-existing key\niex> :shards.get_meta(tab, \"foo foo\")\n:undefined\n\n# With default\niex> :shards.get_meta(tab, \"foo foo\", \"bar bar\")\n\"bar bar\"\n```","ref":"getting-started.html#storing-and-retrieving-custom-metadata-entries"},{"type":"extras","title":"Caching the metadata - Getting Started","doc":"Like it is explained in [shards module](https://hexdocs.pm/shards/shards.html),\nwhen a partitioned table is created there is a metadata associated to it, to\nresolve the number of partitions and other needed attributes. Hence, every time\na function is executed, `shards` has to resolve the metadata first; but this is\ndone internally by `shards`. Nevertheless, `shards` allows to pass the metadata\nas last argument for most of the functions (check the docs to see what functions\nallow it), in case you are able to cache it and use it later for further\noperations. This is possible because the metadata is something doesn't change,\nso it can be easily cached and avoid `shards` the extra step to retrieve it\nfrom the meta table. But be aware this is just an ETS lookup, so the improvement\nis terms of performance may be insignificant, for that reason it is\nrecommendable to evaluate very carefully each scenario and and see if its really\nworth it.\n\n> The overall recommendation is to let `shards` take care of retrieving the\n  metadata and everything else, just use the base `shards` API (ETS API).\n\nIn case you want to cache the metadata:\n\n**Erlang:**\n\n```erlang\n> Tab = shards:new(mytab, [named_table, {partitions, 4}]).\nmytab\n\n> Meta = shards:table_meta(Tab).\n{meta,<0.174.0>,1,4,fun erlang:phash2/2,false,[named_table]}\n```\n\n**Elixir:**\n\n```elixir\niex> tab = :shards.new(:mytab, [:named_table, partitions: 4])\n:mytab\n\niex> meta = :shards.meta(tab)\n{:meta, #PID<0.163.0>, 1, 4, &:erlang.phash2/2, false, [:named_table]}\n```\n\nThen, you can use it for most of the functions (check the docs):\n\n**Erlang:**\n\n```erlang\n> shards:insert(Tab, [{a, 1}, {b, 2}], Meta).\ntrue\n\n> shards:lookup(Tab, a, Meta).\n[{a,1}]\n\n> shards:lookup_element(Tab, a, 2, Meta).\n1\n```\n\n**Elixir:**\n\n```elixir\niex> :shards.insert(tab, [a: 1, b: 2], meta)\ntrue\n\niex> :shards.lookup(tab, :a, meta)\n[a: 1]\n\niex> :shards.lookup_element(tab, :a, 2, meta)\n1\n```\n\n> **NOTE:** See [shards](https://hexdocs.pm/shards/shards.html) docs for more\n  information about the functions that support receiving the metadata; most of\n  them allow the metadata parameter, but there are few exceptions you should\n  know.","ref":"getting-started.html#caching-the-metadata"},{"type":"extras","title":"Shards","doc":"# Shards\n>","ref":"readme.html"},{"type":"extras","title":"ETS tables on steroids! - Shards","doc":"> Sharding for ETS tables out-of-box.\n\n![CI](https://github.com/cabol/shards/workflows/CI/badge.svg)\n[![Codecov](https://codecov.io/gh/cabol/shards/branch/master/graphs/badge.svg)](https://codecov.io/gh/cabol/shards/branch/master/graphs/badge.svg)\n[![Hex Version](https://img.shields.io/hexpm/v/shards.svg)](https://hex.pm/packages/shards)\n[![Docs](https://img.shields.io/badge/docs-hexpm-blue.svg)](https://hexdocs.pm/shards)\n[![License](https://img.shields.io/hexpm/l/shards.svg)](LICENSE)\n\nWhy might we need **Sharding/Partitioning** for the ETS tables? The main reason\nis to keep the lock contention under control enabling ETS tables to scale out\nand support higher levels of concurrency without lock issues; specially\nwrite-locks, which most of the cases might cause significant performance\ndegradation.\n\nTherefore, one of the most common and proven strategies to deal with these\nproblems is [Sharding][sharding] or [Partitioning][partitioning]; the principle\nis pretty similar to [DHTs][dht].\n\nThis is where [shards][shards] comes in. [Shards][shards] is an Erlang/Elixir\nlibrary fully compatible with the [ETS API][ets_api], but it implements sharding\nor partitioning on top of the ETS tables, completely transparent and out-of-box.\n\nSee the **[getting started][getting_started]** guide\nand the **[online documentation](https://hexdocs.pm/shards/)**.\n\n[ets_api]: http://erlang.org/doc/man/ets.html\n[sharding]: https://en.wikipedia.org/wiki/Shard_(database_architecture)\n[partitioning]: https://en.wikipedia.org/wiki/Partition_(database)\n[dht]: https://en.wikipedia.org/wiki/Distributed_hash_table\n[shards]: https://hexdocs.pm/shards/shards.html\n[getting_started]: https://hexdocs.pm/shards/getting-started.html","ref":"readme.html#ets-tables-on-steroids"},{"type":"extras","title":"Installation - Shards","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Erlang - Shards","doc":"In your `rebar.config`:\n\n```erlang\n{deps, [\n  {shards, \"1.1.0\"}\n]}.\n```","ref":"readme.html#erlang"},{"type":"extras","title":"Elixir - Shards","doc":"In your `mix.exs`:\n\n```elixir\ndef deps do\n  [{:shards, \"~> 1.1\"}]\nend\n```\n\n> For more information and examples, see the [getting started][getting_started]\n  guide.","ref":"readme.html#elixir"},{"type":"extras","title":"Important links - Shards","doc":"* [Blog Post](http://cabol.github.io/posts/2016/04/14/sharding-support-for-ets.html) -\n    Transparent and out-of-box sharding support for ETS tables in Erlang/Elixir.\n\n  * Projects using **shards**:\n    * [shards_dist](https://github.com/cabol/shards_dist) - Distributed version\n      of `shards`. It was moved to a separate repo since `v1.0.0`.\n    * [Nebulex](https://github.com/cabol/nebulex) – Distributed Caching\n      framework for Elixir.\n    * [ExShards](https://github.com/cabol/ex_shards) – Elixir wrapper for\n      `shards`; with extra and nicer functions.\n    * [KVX](https://github.com/cabol/kvx) – Simple Elixir in-memory Key/Value\n      Store using `shards` (default adapter).\n    * [Cacherl](https://github.com/ferigis/cacherl) Distributed Cache\n      using `shards`.","ref":"readme.html#important-links"},{"type":"extras","title":"Testing - Shards","doc":"```\n$ make test\n```\n\nYou can find tests results in `_build/test/logs`, and coverage in\n`_build/test/cover`.\n\n> **NOTE:** `shards` comes with a helper `Makefile`, but it is just a simple\n  wrapper on top of `rebar3`, therefore, you can do everything using `rebar3`\n  directly as well (e.g.: `rebar3 do ct, cover`).","ref":"readme.html#testing"},{"type":"extras","title":"Generating Edoc - Shards","doc":"```\n$ make docs\n```\n\n> **NOTE:** Once you run the previous command, you will find the generated HTML\n  documentation within `doc` folder; open `doc/index.html`.","ref":"readme.html#generating-edoc"},{"type":"extras","title":"Contributing - Shards","doc":"Contributions to **shards** are very welcome and appreciated!\n\nUse the [issue tracker](https://github.com/cabol/shards/issues) for bug reports\nor feature requests. Open a [pull request](https://github.com/cabol/shards/pulls)\nwhen you are ready to contribute.\n\nWhen submitting a pull request you should not update the [CHANGELOG.md](CHANGELOG.md),\nand also make sure you test your changes thoroughly, include unit tests\nalongside new or changed code.\n\nBefore to submit a PR it is highly recommended to run `make check` before and\nensure all checks run successfully.","ref":"readme.html#contributing"},{"type":"extras","title":"Copyright and License - Shards","doc":"Copyright (c) 2016 Carlos Andres Bolaños R.A.\n\n**Shards** source code is licensed under the [MIT License](LICENSE).","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThis project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [v1.1.1](https://github.com/cabol/shards/tree/v1.1.1) (2024-05-25)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v1.1.0...v1.1.1)\n\n**Closed issues:**\n\n- Compilation error with OTP 26\n  [#63](https://github.com/cabol/shards/issues/63)\n- `shards:info/1` bad argument crash\n  [#60](https://github.com/cabol/shards/issues/60)\n\n## [v1.1.0](https://github.com/cabol/shards/tree/v1.1.0) (2022-11-25)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v1.0.1...v1.1.0)\n\n**Implemented enhancements:**\n\n- Add helper functions for storing and retrieving custom metadata\n  [814ebf1](https://github.com/cabol/shards/commit/814ebf1f12e0a9e17ee2788ad8dbe4627b5c1d9b).\n- Overall fixes, updates, and improvements\n  [474ca04](https://github.com/cabol/shards/commit/474ca045d26e38aa33ca19b65d9ec180eb31b0c5).\n- Add rebar3_ex_doc for generating docs\n  [5070f4a](https://github.com/cabol/shards/commit/5070f4a9538ae8280f28860738579b8c8678ebd5).\n\n## [v1.0.1](https://github.com/cabol/shards/tree/v1.0.1) (2020-11-07)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v1.0.0...v1.0.1)\n\n**Fixed bugs:**\n\n- Paginated select/match raises `badarg` when used with large data\n  [#59](https://github.com/cabol/shards/issues/59).\n\n**Implemented enhancements:**\n\n- Added property tests for base read/write commands.\n\n## [v1.0.0](https://github.com/cabol/shards/tree/v1.0.0) (2020-10-28)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.6.2...v1.0.0)\n\n**Implemented enhancements:**\n\n- Make `shards` just a library to work locally and move `shards_dist` to a\n  [separate project/repo](https://github.com/cabol/shards_dist)\n  [#52](https://github.com/cabol/shards/issues/52).\n- Use the metadata ETS table for storing the partitions TIDs, instead of\n  building atoms in runtime for table names [#55](https://github.com/cabol/shards/issues/55).\n- Refactor shards to use TIDs instead of names (atoms) for handling the\n  partitions [#54](https://github.com/cabol/shards/issues/54).\n- Support named and unnamed tables [#53](https://github.com/cabol/shards/issues/53).\n- Create the module `shards_group` as dynamic supervisor for creating/deleting\n  tables dynamically as part of a supervision tree [#56](https://github.com/cabol/shards/issues/56).\n- Add module `shards_enum` for the enumerable-based functions.\n- Add simple implementation for `shards_enum:pmap/2,3` to support parallel\n  execution.\n- Make configurable parallel execution for operations involving all partitions\n  (like query-based functions) via `parallel` option. See `shards:new/2`.\n- Make configurable the max timeout for parallel executions via\n  `parallel_timeout` option. See `shards:new/2`.\n- Remove module `shards_task` since it is overkill and not needed anymore.\n- Fix and/or improve docs.\n\n**Closed issues:**\n\n- Shards `0.6.2` doesn't compile on OTP 23.0.3 on OS X 10.15\n  [#48](https://github.com/cabol/shards/issues/48).\n- Migrate from pg2 to pg (OTP 23) [#47](https://github.com/cabol/shards/issues/47).\n- Support for `select_replace` [#45](https://github.com/cabol/shards/issues/45).\n- Fix `shards_dist` and `shards` specs to consider the case when `rpc` returns\n  `{badrpc, Reason}` [#43](https://github.com/cabol/shards/issues/43).\n\n**Merged pull requests:**\n\n- Prepare v1.0.0 [#51](https://github.com/cabol/shards/pull/51)\n\n## [v0.6.2](https://github.com/cabol/shards/tree/v0.6.2) (2020-03-23)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.6.1...v0.6.2)\n\n**Closed issues:**\n\n- Rollback when `insert_new` fails [#46](https://github.com/cabol/shards/issues/46)\n\n## [v0.6.1](https://github.com/cabol/shards/tree/v0.6.1) (2019-11-05)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.6.0...v0.6.1)\n\n**Closed issues:**\n\n- Missing support for keypos [#44](https://github.com/cabol/shards/issues/44)\n- `update_counter` spec is not the same as ETS. [#42](https://github.com/cabol/shards/issues/42)\n- Failed to start `shard_sup` [#41](https://github.com/cabol/shards/issues/41)\n\n## [v0.6.0](https://github.com/cabol/shards/tree/v0.6.0) (2018-09-02)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.5.1...v0.6.0)\n\n**Implemented enhancements:**\n\n- Improve documentation [#39](https://github.com/cabol/shards/issues/39)\n\n## [v0.5.1](https://github.com/cabol/shards/tree/v0.5.1) (2018-06-26)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.5.0...v0.5.1)\n\n**Closed issues:**\n\n- Issues on Erlang v21 [#40](https://github.com/cabol/shards/issues/40)\n- Improve test coverage \\(ideally 100%\\) [#38](https://github.com/cabol/shards/issues/38)\n\n## [v0.5.0](https://github.com/cabol/shards/tree/v0.5.0) (2017-07-11)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.4.2...v0.5.0)\n\n**Implemented enhancements:**\n\n- Improve `shards_local:info/1,2` to be compliant with ETS functions\n  [#37](https://github.com/cabol/shards/issues/37)\n- Improve `file2tab` and `tab2file` in `shards_local` to be compliant with ETS\n  functions [#36](https://github.com/cabol/shards/issues/36)\n- Improve `shards_local` fix \\#4 – `ordered_set` support.\n  [#25](https://github.com/cabol/shards/issues/25)\n\n**Closed issues:**\n\n- Allows to register `shards_sup` with custom name (given as parameter)\n  [#34](https://github.com/cabol/shards/issues/34)\n- `file2tab`, `tab2file` not working [#33](https://github.com/cabol/shards/issues/33)\n\n**Merged pull requests:**\n\n- Improve README grammar [#35](https://github.com/cabol/shards/pull/35)\n  ([casidiablo](https://github.com/casidiablo))\n\n## [v0.4.2](https://github.com/cabol/shards/tree/v0.4.2) (2017-02-22)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.4.1...v0.4.2)\n\n**Closed issues:**\n\n- Implement `ets:rename/2` [#32](https://github.com/cabol/shards/issues/32)\n- Fulfil ETS API for `shards_local` [#1](https://github.com/cabol/shards/issues/1)\n\n## [v0.4.1](https://github.com/cabol/shards/tree/v0.4.1) (2017-02-13)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.4.0...v0.4.1)\n\n**Implemented enhancements:**\n\n- Automatically distributed table setup when `shards:new/2` is called with\n  opt `{nodes, \\[node\\(\\)\\]}` [#28](https://github.com/cabol/shards/issues/28)\n- Implement `select/match` pagination ops for `shards_dist`\n  [#16](https://github.com/cabol/shards/issues/16)\n\n**Closed issues:**\n\n- Implement `update_counter` and `update_element` in `shards_dist`\n  [#31](https://github.com/cabol/shards/issues/31)\n- LRU Feature may be [#29](https://github.com/cabol/shards/issues/29)\n\n## [v0.4.0](https://github.com/cabol/shards/tree/v0.4.0) (2017-02-10)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.3.1...v0.4.0)\n\n**Implemented enhancements:**\n\n- Allow to create the `state` passing the rest of its attributes\n  [#30](https://github.com/cabol/shards/issues/30)\n\n**Closed issues:**\n\n- Add performance and scalability tests [#2](https://github.com/cabol/shards/issues/2)\n\n## [v0.3.1](https://github.com/cabol/shards/tree/v0.3.1) (2016-09-08)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.3.0...v0.3.1)\n\n**Implemented enhancements:**\n\n- Modify `shards:new/2` function to return only the table name in case of\n  success [#27](https://github.com/cabol/shards/issues/27)\n\n## [v0.3.0](https://github.com/cabol/shards/tree/v0.3.0) (2016-08-02)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.2.0...v0.3.0)\n\n**Implemented enhancements:**\n\n- Allow to call `shards_local` without the state – using a default state.\n  [#23](https://github.com/cabol/shards/issues/23)\n- Unify `pick_shard_fun` and `pick_node_fun` in a single spec\n  [#22](https://github.com/cabol/shards/issues/22)\n- Separate `shards` from specific consistent hashing implementation.\n  [#21](https://github.com/cabol/shards/issues/21)\n\n**Closed issues:**\n\n- Remove `auto_eject_nodes` property from `state` – it isn't being used\n  [#24](https://github.com/cabol/shards/issues/24)\n- Fix `shards` to work well with `ordered_set` tables.\n  [#4](https://github.com/cabol/shards/issues/4)\n\n## [v0.2.0](https://github.com/cabol/shards/tree/v0.2.0) (2016-07-10)\n\n[Full Changelog](https://github.com/cabol/shards/compare/v0.1.0...v0.2.0)\n\n**Implemented enhancements:**\n\n- Modify `shards_local` to avoid additional table types, handle a flag\n  `sharded` instead. [#10](https://github.com/cabol/shards/issues/10)\n- Make distribution function \\(pick none/shard\\) configurable.\n  [#9](https://github.com/cabol/shards/issues/9)\n- Implement sharding at global level. [#3](https://github.com/cabol/shards/issues/3)\n\n**Closed issues:**\n\n- OTP \\< 18 not supported [#13](https://github.com/cabol/shards/issues/13)\n- rebar2 compatibility [#12](https://github.com/cabol/shards/issues/12)\n\n**Merged pull requests:**\n\n- General fixes and refactoring. [#19](https://github.com/cabol/shards/pull/19) ([cabol](https://github.com/cabol))\n- v0.2.0 [#18](https://github.com/cabol/shards/pull/18) ([cabol](https://github.com/cabol))\n- Preparing v0.2.0. [#17](https://github.com/cabol/shards/pull/17) ([cabol](https://github.com/cabol))\n- v0.1.1 [#15](https://github.com/cabol/shards/pull/15) ([cabol](https://github.com/cabol))\n- Enhancements and fix issue \\#13. [#14](https://github.com/cabol/shards/pull/14) ([cabol](https://github.com/cabol))\n\n## [v0.1.0](https://github.com/cabol/shards/tree/v0.1.0) (2016-05-19)\n\n[Full Changelog](https://github.com/cabol/shards/compare/765c5e9f6e350b46076d8a525ac0d18fba909e27...v0.1.0)\n\n**Closed issues:**\n\n- Operation of the shards:info/2 does not match [#8](https://github.com/cabol/shards/issues/8)\n\n**Merged pull requests:**\n\n- Fix README. [#7](https://github.com/cabol/shards/pull/7) ([cabol](https://github.com/cabol))\n- Refactor shards_local to handle 'state' and avoid to call ETS control table.\n  [#6](https://github.com/cabol/shards/pull/6) ([cabol](https://github.com/cabol))\n- Implemented distributed shards. [#5](https://github.com/cabol/shards/pull/5)\n  ([cabol](https://github.com/cabol))\n\n\n\\* *This Changelog was automatically generated by [github_changelog_generator](https://github.com/github-changelog-generator/github-changelog-generator)*","ref":"changelog.html"},{"type":"extras","title":"LICENSE","doc":"The MIT License (MIT)\n\nCopyright (c) 2016 Carlos Andres Bolaños R.A.\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}